/**
 * @file FootyDocUndo.cpp
 * @brief hLgǗNXB̃t@CŃAhD̏s܂B
 * @author Shinji Watanabe
 * @date 2009/01/11
 */

#include "FootyDoc.h"
#include "UndoBuffer.h"

//-----------------------------------------------------------------------------
/**
 * @brief AhD𖖔ɑ}܂B
 */
bool CFootyDoc::PushBackUndo(CUndoBuffer *pUndo)
{
	FOOTY2_ASSERT( !IsReadOnly() );

	if (!pUndo)return false;
	if (m_pNowUndoPos == m_lsUndoBuffer.end())		// AhDsĂȂ
	{
		m_lsUndoBuffer.push_back(*pUndo);
		/*Z[u|CgɊւ鏈*/
		if (!m_bCannotReachSavedPos &&				// AhDւ̓B\
			m_pSavedPos == m_lsUndoBuffer.end())	// ŏ̃AhDZbĝƂ
			m_pSavedPos--;							// OAhD̈ʒuƂȂ
	}
	else											// AhDsĂ
	{
		// ʒuɃZ[u|Cg܂܂Ă邩ǂׂ
		if (!m_bCannotReachSavedPos)
		{
			std::list<CUndoBuffer>::iterator iterUndo;
			for (iterUndo = m_pNowUndoPos;iterUndo != m_lsUndoBuffer.end();iterUndo++)
			{
				if (iterUndo == m_pSavedPos)
				{
					m_pSavedPos = m_lsUndoBuffer.end();
					m_bCannotReachSavedPos = true;
				}
			}
		}
		// obt@̑
		m_lsUndoBuffer.erase(m_pNowUndoPos,m_lsUndoBuffer.end());	// Ō܂ŏ
		m_lsUndoBuffer.push_back(*pUndo);							// Ōɑ}
		m_pNowUndoPos = m_lsUndoBuffer.end();						// xAhDĂȂƂɂ
	}
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief AhDs܂B
 */
bool CFootyDoc::Undo()
{
	if ( IsReadOnly() ) return false;

	// ݂̃AhD[ʒu擾
	if (m_pNowUndoPos == m_lsUndoBuffer.end())		// ܂sĂȂ
	{
		if (!m_lsUndoBuffer.size())
			return false;
	}
	else if (m_pNowUndoPos == m_lsUndoBuffer.begin())
	{
		return false;
	}
	m_pNowUndoPos --;

	// R}hɏ]ăAhDs܂B
	switch(m_pNowUndoPos->m_nUndoType)
	{
	case CUndoBuffer::UNDOTYPE_DELETE:
		m_pNowUndoPos->m_cBeforeStart.SetPosition(&m_cCaretPos,&m_lsLines);
		InsertString(m_pNowUndoPos->m_strBefore.c_str(),false);
		break;
	case CUndoBuffer::UNDOTYPE_INSERT:
		SetSelectStart(&m_pNowUndoPos->m_cAfterStart);
		SetSelectEndNormal(&m_pNowUndoPos->m_cAfterEnd);
		DeleteSelected(NULL);
		break;
	case CUndoBuffer::UNDOTYPE_REPLACE:
		SetSelectStart(&m_pNowUndoPos->m_cAfterStart);
		SetSelectEndNormal(&m_pNowUndoPos->m_cAfterEnd);
		InsertString(m_pNowUndoPos->m_strBefore.c_str(),false);
		break;
	}
	SendMoveCaretCallBack();
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief hDs܂B
 */
bool CFootyDoc::Redo()
{
	if ( IsReadOnly() ) return false;

	// ݂̃hD[ʒu擾
	if (m_pNowUndoPos == m_lsUndoBuffer.end())
		return false;
	
	// R}hɏ]ăAhDs܂B
	switch(m_pNowUndoPos->m_nUndoType)
	{
	case CUndoBuffer::UNDOTYPE_DELETE:
		SetSelectStart(&m_pNowUndoPos->m_cBeforeStart);
		SetSelectEndNormal(&m_pNowUndoPos->m_cBeforeEnd);
		DeleteSelected(NULL);
		break;
	case CUndoBuffer::UNDOTYPE_INSERT:
		m_pNowUndoPos->m_cAfterStart.SetPosition(&m_cCaretPos,&m_lsLines);
		InsertString(m_pNowUndoPos->m_strAfter.c_str(),false);
		break;
	case CUndoBuffer::UNDOTYPE_REPLACE:
		SetSelectStart(&m_pNowUndoPos->m_cBeforeStart);
		SetSelectEndNormal(&m_pNowUndoPos->m_cBeforeEnd);
		InsertString(m_pNowUndoPos->m_strAfter.c_str(),false);
		break;
	}
	
	// ̃AhD[
	m_pNowUndoPos ++;
	SendMoveCaretCallBack();
	return true;
}

/*[EOF]*/
